<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for QuickMessageLog StructType
 * @subpackage Structs
 */
class QuickMessageLog extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The mServiceId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $mServiceId;
    /**
     * The mDriverId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $mDriverId;
    /**
     * The mStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $mStatus;
    /**
     * The mId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mId;
    /**
     * The mMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mMessage;
    /**
     * The mDateRec
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mDateRec;
    /**
     * The mDateResp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mDateResp;
    /**
     * Constructor method for QuickMessageLog
     * @uses QuickMessageLog::setId()
     * @uses QuickMessageLog::setMServiceId()
     * @uses QuickMessageLog::setMDriverId()
     * @uses QuickMessageLog::setMStatus()
     * @uses QuickMessageLog::setMId()
     * @uses QuickMessageLog::setMMessage()
     * @uses QuickMessageLog::setMDateRec()
     * @uses QuickMessageLog::setMDateResp()
     * @param int $id
     * @param int $mServiceId
     * @param int $mDriverId
     * @param int $mStatus
     * @param string $mId
     * @param string $mMessage
     * @param string $mDateRec
     * @param string $mDateResp
     */
    public function __construct($id = null, $mServiceId = null, $mDriverId = null, $mStatus = null, $mId = null, $mMessage = null, $mDateRec = null, $mDateResp = null)
    {
        $this
            ->setId($id)
            ->setMServiceId($mServiceId)
            ->setMDriverId($mDriverId)
            ->setMStatus($mStatus)
            ->setMId($mId)
            ->setMMessage($mMessage)
            ->setMDateRec($mDateRec)
            ->setMDateResp($mDateResp);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\QuickMessageLog
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get mServiceId value
     * @return int
     */
    public function getMServiceId()
    {
        return $this->mServiceId;
    }
    /**
     * Set mServiceId value
     * @param int $mServiceId
     * @return \StructType\QuickMessageLog
     */
    public function setMServiceId($mServiceId = null)
    {
        // validation for constraint: int
        if (!is_null($mServiceId) && !(is_int($mServiceId) || ctype_digit($mServiceId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($mServiceId, true), gettype($mServiceId)), __LINE__);
        }
        $this->mServiceId = $mServiceId;
        return $this;
    }
    /**
     * Get mDriverId value
     * @return int
     */
    public function getMDriverId()
    {
        return $this->mDriverId;
    }
    /**
     * Set mDriverId value
     * @param int $mDriverId
     * @return \StructType\QuickMessageLog
     */
    public function setMDriverId($mDriverId = null)
    {
        // validation for constraint: int
        if (!is_null($mDriverId) && !(is_int($mDriverId) || ctype_digit($mDriverId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($mDriverId, true), gettype($mDriverId)), __LINE__);
        }
        $this->mDriverId = $mDriverId;
        return $this;
    }
    /**
     * Get mStatus value
     * @return int
     */
    public function getMStatus()
    {
        return $this->mStatus;
    }
    /**
     * Set mStatus value
     * @param int $mStatus
     * @return \StructType\QuickMessageLog
     */
    public function setMStatus($mStatus = null)
    {
        // validation for constraint: int
        if (!is_null($mStatus) && !(is_int($mStatus) || ctype_digit($mStatus))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($mStatus, true), gettype($mStatus)), __LINE__);
        }
        $this->mStatus = $mStatus;
        return $this;
    }
    /**
     * Get mId value
     * @return string|null
     */
    public function getMId()
    {
        return $this->mId;
    }
    /**
     * Set mId value
     * @param string $mId
     * @return \StructType\QuickMessageLog
     */
    public function setMId($mId = null)
    {
        // validation for constraint: string
        if (!is_null($mId) && !is_string($mId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mId, true), gettype($mId)), __LINE__);
        }
        $this->mId = $mId;
        return $this;
    }
    /**
     * Get mMessage value
     * @return string|null
     */
    public function getMMessage()
    {
        return $this->mMessage;
    }
    /**
     * Set mMessage value
     * @param string $mMessage
     * @return \StructType\QuickMessageLog
     */
    public function setMMessage($mMessage = null)
    {
        // validation for constraint: string
        if (!is_null($mMessage) && !is_string($mMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mMessage, true), gettype($mMessage)), __LINE__);
        }
        $this->mMessage = $mMessage;
        return $this;
    }
    /**
     * Get mDateRec value
     * @return string|null
     */
    public function getMDateRec()
    {
        return $this->mDateRec;
    }
    /**
     * Set mDateRec value
     * @param string $mDateRec
     * @return \StructType\QuickMessageLog
     */
    public function setMDateRec($mDateRec = null)
    {
        // validation for constraint: string
        if (!is_null($mDateRec) && !is_string($mDateRec)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mDateRec, true), gettype($mDateRec)), __LINE__);
        }
        $this->mDateRec = $mDateRec;
        return $this;
    }
    /**
     * Get mDateResp value
     * @return string|null
     */
    public function getMDateResp()
    {
        return $this->mDateResp;
    }
    /**
     * Set mDateResp value
     * @param string $mDateResp
     * @return \StructType\QuickMessageLog
     */
    public function setMDateResp($mDateResp = null)
    {
        // validation for constraint: string
        if (!is_null($mDateResp) && !is_string($mDateResp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mDateResp, true), gettype($mDateResp)), __LINE__);
        }
        $this->mDateResp = $mDateResp;
        return $this;
    }
}
