<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendCmdResponse StructType
 * @subpackage Structs
 */
class SendCmdResponse extends AbstractStructBase
{
    /**
     * The error_code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $error_code;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The cmdId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cmdId;
    /**
     * The cId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cId;
    /**
     * Constructor method for SendCmdResponse
     * @uses SendCmdResponse::setError_code()
     * @uses SendCmdResponse::setStatus()
     * @uses SendCmdResponse::setDescription()
     * @uses SendCmdResponse::setCmdId()
     * @uses SendCmdResponse::setCId()
     * @param int $error_code
     * @param string $status
     * @param string $description
     * @param string $cmdId
     * @param string $cId
     */
    public function __construct($error_code = null, $status = null, $description = null, $cmdId = null, $cId = null)
    {
        $this
            ->setError_code($error_code)
            ->setStatus($status)
            ->setDescription($description)
            ->setCmdId($cmdId)
            ->setCId($cId);
    }
    /**
     * Get error_code value
     * @return int
     */
    public function getError_code()
    {
        return $this->error_code;
    }
    /**
     * Set error_code value
     * @param int $error_code
     * @return \StructType\SendCmdResponse
     */
    public function setError_code($error_code = null)
    {
        // validation for constraint: int
        if (!is_null($error_code) && !(is_int($error_code) || ctype_digit($error_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($error_code, true), gettype($error_code)), __LINE__);
        }
        $this->error_code = $error_code;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\SendCmdResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\SendCmdResponse
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get cmdId value
     * @return string|null
     */
    public function getCmdId()
    {
        return $this->cmdId;
    }
    /**
     * Set cmdId value
     * @param string $cmdId
     * @return \StructType\SendCmdResponse
     */
    public function setCmdId($cmdId = null)
    {
        // validation for constraint: string
        if (!is_null($cmdId) && !is_string($cmdId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cmdId, true), gettype($cmdId)), __LINE__);
        }
        $this->cmdId = $cmdId;
        return $this;
    }
    /**
     * Get cId value
     * @return string|null
     */
    public function getCId()
    {
        return $this->cId;
    }
    /**
     * Set cId value
     * @param string $cId
     * @return \StructType\SendCmdResponse
     */
    public function setCId($cId = null)
    {
        // validation for constraint: string
        if (!is_null($cId) && !is_string($cId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cId, true), gettype($cId)), __LINE__);
        }
        $this->cId = $cId;
        return $this;
    }
}
