<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TripsAndPcounter_Response StructType
 * @subpackage Structs
 */
class TripsAndPcounter_Response extends AbstractStructBase
{
    /**
     * The error_code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $error_code;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The tripsAndPcounter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTripsAndPcounter
     */
    public $tripsAndPcounter;
    /**
     * Constructor method for TripsAndPcounter_Response
     * @uses TripsAndPcounter_Response::setError_code()
     * @uses TripsAndPcounter_Response::setStatus()
     * @uses TripsAndPcounter_Response::setDescription()
     * @uses TripsAndPcounter_Response::setTripsAndPcounter()
     * @param int $error_code
     * @param string $status
     * @param string $description
     * @param \ArrayType\ArrayOfTripsAndPcounter $tripsAndPcounter
     */
    public function __construct($error_code = null, $status = null, $description = null, \ArrayType\ArrayOfTripsAndPcounter $tripsAndPcounter = null)
    {
        $this
            ->setError_code($error_code)
            ->setStatus($status)
            ->setDescription($description)
            ->setTripsAndPcounter($tripsAndPcounter);
    }
    /**
     * Get error_code value
     * @return int
     */
    public function getError_code()
    {
        return $this->error_code;
    }
    /**
     * Set error_code value
     * @param int $error_code
     * @return \StructType\TripsAndPcounter_Response
     */
    public function setError_code($error_code = null)
    {
        // validation for constraint: int
        if (!is_null($error_code) && !(is_int($error_code) || ctype_digit($error_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($error_code, true), gettype($error_code)), __LINE__);
        }
        $this->error_code = $error_code;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\TripsAndPcounter_Response
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\TripsAndPcounter_Response
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get tripsAndPcounter value
     * @return \ArrayType\ArrayOfTripsAndPcounter|null
     */
    public function getTripsAndPcounter()
    {
        return $this->tripsAndPcounter;
    }
    /**
     * Set tripsAndPcounter value
     * @param \ArrayType\ArrayOfTripsAndPcounter $tripsAndPcounter
     * @return \StructType\TripsAndPcounter_Response
     */
    public function setTripsAndPcounter(\ArrayType\ArrayOfTripsAndPcounter $tripsAndPcounter = null)
    {
        $this->tripsAndPcounter = $tripsAndPcounter;
        return $this;
    }
}
