<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VhsActiveInItineraryResponse StructType
 * @subpackage Structs
 */
class VhsActiveInItineraryResponse extends AbstractStructBase
{
    /**
     * The error_code
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $error_code;
    /**
     * The hasActiveMobiles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $hasActiveMobiles;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * Constructor method for VhsActiveInItineraryResponse
     * @uses VhsActiveInItineraryResponse::setError_code()
     * @uses VhsActiveInItineraryResponse::setHasActiveMobiles()
     * @uses VhsActiveInItineraryResponse::setStatus()
     * @uses VhsActiveInItineraryResponse::setDescription()
     * @param int $error_code
     * @param bool $hasActiveMobiles
     * @param string $status
     * @param string $description
     */
    public function __construct($error_code = null, $hasActiveMobiles = null, $status = null, $description = null)
    {
        $this
            ->setError_code($error_code)
            ->setHasActiveMobiles($hasActiveMobiles)
            ->setStatus($status)
            ->setDescription($description);
    }
    /**
     * Get error_code value
     * @return int
     */
    public function getError_code()
    {
        return $this->error_code;
    }
    /**
     * Set error_code value
     * @param int $error_code
     * @return \StructType\VhsActiveInItineraryResponse
     */
    public function setError_code($error_code = null)
    {
        // validation for constraint: int
        if (!is_null($error_code) && !(is_int($error_code) || ctype_digit($error_code))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($error_code, true), gettype($error_code)), __LINE__);
        }
        $this->error_code = $error_code;
        return $this;
    }
    /**
     * Get hasActiveMobiles value
     * @return bool
     */
    public function getHasActiveMobiles()
    {
        return $this->hasActiveMobiles;
    }
    /**
     * Set hasActiveMobiles value
     * @param bool $hasActiveMobiles
     * @return \StructType\VhsActiveInItineraryResponse
     */
    public function setHasActiveMobiles($hasActiveMobiles = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasActiveMobiles) && !is_bool($hasActiveMobiles)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hasActiveMobiles, true), gettype($hasActiveMobiles)), __LINE__);
        }
        $this->hasActiveMobiles = $hasActiveMobiles;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\VhsActiveInItineraryResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\VhsActiveInItineraryResponse
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
}
